﻿
; #Au3Stripper_Parameters=/MO

#include <Inet.au3>
#include <Array.au3>
#include <String.au3>

Global $searchstring
Global $bigtranslation
$bigtranslation = "" 

#cs

Rename your script from simplegoog###.au3 to simplegoog#YOUR_API_KEY#source_language#target_language.au3

#ce

#cs

Okay, for the "premium" GT we can only send one sentence per URL.

Eventually, we must also check that each sentence is smaller than 1500 characters, and we must check that we don't send more than 1000 requests per 100 seconds.

Oh, and we also have to check the JSON reply to see if the translation that was sent is actually premium or standard.

#ce

HotKeySet("^`", "DoTheTranslation")

If StringInStr (@ScriptName, "###", 1) Then
$apikey = InputBox ("Enter API key", "What is your API key?")
If @error = 1 Then
Exit
EndIf
$SL = InputBox ("Enter source language", "What is your source language?")
If @error = 1 Then
Exit
EndIf
$TL= InputBox ("Enter target language", "What is your target language?")
If @error = 1 Then
Exit
EndIf
Else
$scriptnamesplit = StringSplit (@ScriptName, "#", 1)
If $scriptnamesplit[0] = 4 Then
$apikey = $scriptnamesplit[2]
$SL = $scriptnamesplit[3]
$TL = StringTrimRight ($scriptnamesplit[4], 4)
$scriptnamesplitinfo = MsgBox (4, "Is this information correct?", "API key: " & $apikey & @CRLF & "Source language code: " & $SL & @CRLF & "Target language code: " & $TL, 0)
If $scriptnamesplitinfo = 7 Then
$apikey = InputBox ("Enter API key", "What is your API key?", $apikey)
If @error = 1 Then
Exit
EndIf
$SL = InputBox ("Enter source language", "What is your source language?", $SL)
If @error = 1 Then
Exit
EndIf
$TL= InputBox ("Enter target language", "What is your target language?", $TL)
If @error = 1 Then
Exit
EndIf
EndIf
Else
MsgBox (0, "Error 2", "Could not get API key, source language code or target language code from script file name." & @CRLF & "The script will now exit.", 0)
Exit
EndIf
EndIf

$mustaskforfile = 0

While 1
Sleep ("100")
WEnd

Func DoTheTranslation ()

$cliporno = 6

Send ("^c")

$inputfile = ClipGet () ; since this this version of the script deals only with the clipboard

$modex = "&model=nmt" ; since this version of the script is specifically for NMT translations

$splitbysentence = 7 ; since we're not splitting by sentence in this version of the script

$howtodisplay = 2 ; since this version of the script displays the tranlsation in one way only

$numofstrings = 0

$searchstring = $inputfile

If $searchstring = "" Then
MsgBox (0, "", "Nothing to translate!", 0)
Return
EndIf

$searchstring = StringToBinary ($searchstring, 4)
$searchstring = StringTrimLeft ($searchstring, 2)

$searchstring = StringRegExpReplace ($searchstring, "(..)", "%\1")

If StringRight ($searchstring, 2) = "00" Then
$searchstring = StringTrimRight ($searchstring, 2)
EndIf

; I have honestly no idea what this is for:
If StringRight ($searchstring, 3) = "" Then
$searchstring = StringTrimRight ($searchstring, 3)
EndIf

; use translation.googleapis.com instead, since this is premium
; $foo = InetRead ("https://www.googleapis.com/language/translate/v2?key=" & $apikey & $modex & "&source=" & $SL & "&target=" & $TL & $searchstring, 0)

$foo = InetRead ("https://translation.googleapis.com/language/translate/v2?key=" & $apikey & $modex & "&source=" & $SL & "&target=" & $TL & "&q=" & $searchstring, 0)

$error = 0

If @error Then
$error = @error
; ClipPut ("https://www.googleapis.com/language/translate/v2?key=" & $apikey & $modex & "&source=" & $SL & "&target=" & $TL & $searchstring)
; ClipPut ("https://translation.googleapis.com/language/translate/v2?key=" & $apikey & $modex & "&source=" & $SL & "&target=" & $TL & "&q=" & $searchstring)
; MsgBox (0, "Error #" & $error, "Google is unhappy with the request.  We've added the URL to the clipboard.  Try pasting it in a browser and see if there's an error message. Also double-check if the URL you paste is the same as the URL that is left after the page is visited.  After you click 'OK', it will no longer be on the clipboard.", 0)
$urllength = StringLen ("https://translation.googleapis.com/language/translate/v2?key=" & $apikey & $modex & "&source=" & $SL & "&target=" & $TL & "&q=" & $searchstring)
$translation = "Unknown error. By the way, the URL is " & $urllength & " characters long."
$translationS = "N/A"
MsgBox (0, "", $translation, 0)
$error = 1

Else

$foo = BinaryToString ($foo, 4)

If StringInStr ($foo, '"model": "nmt"') Then
$premiumornot = "P"
Else
$premiumornot = "S"
If $howtodisplay = 2 Then
MsgBox (0, "Warning!", "Google sent a STANDARD translation instead of a premium translation." & @CRLF & @CRLF & $inputfile & @CRLF & @CRLF & $foo, 10)
EndIf
EndIf

If StringInStr ($foo, '"errors": [') Then
MsgBox (0, "Google throws an error...", $foo, 0)
Else

$foosplit = StringSplit ($foo, '"translatedText": "', 1)

$foosplit2 = StringSplit ($foosplit[2], '"', 1)
$translation = $foosplit2[1]

$translation = StringReplace ($translation, "\u200b", "")
$translation = StringReplace ($translation, "&#39;", "'")
$translation = StringReplace ($translation, "&quot;", '"')
$translation = StringReplace ($translation, "&amp;", '&')
$translation = StringReplace ($translation, "\u003c", '<')
$translation = StringReplace ($translation, "\u003e", '>')
$translation = StringReplace ($translation, "&lt;", '<')
$translation = StringReplace ($translation, "&gt;", '>')

#cs
; -- ; let's keep this here in case we need it later

If $howtodisplay = 4 Then

$foox = InetRead ("https://www.googleapis.com/language/translate/v2?key=" & $apikey & "&source=" & $SL & "&target=" & $TL & "&q=" & $searchstring, 0)

If @error Then
$error = @error
ClipPut ("https://www.googleapis.com/language/translate/v2?key=" & $apikey & "&source=" & $SL & "&target=" & $TL & "&q=" & $searchstring)
MsgBox (0, "Error #" & $error, "Google is unhappy with the request.  We've added the URL to the clipboard.  Try pasting it in a browser and see if there's an error message. Also double-check if the URL you paste is the same as the URL that is left after the page is visited.  After you click 'OK', it will no longer be on the clipboard.", 0)
EndIf

$foox = BinaryToString ($foox, 4)

$fooxsplit = StringSplit ($foox, '"translatedText": "', 1)
$fooxsplit2 = StringSplit ($fooxsplit[2], '"', 1)
$translationS = $fooxsplit2[1]

$translationS = StringReplace ($translationS, "\u200b", "")
$translationS = StringReplace ($translationS, "&#39;", "'")
$translationS = StringReplace ($translationS, "&quot;", '"')
$translationS = StringReplace ($translationS, "&amp;", '&')
$translationS = StringReplace ($translationS, "\u003c", '<')
$translationS = StringReplace ($translationS, "\u003e", '>')
$translationS = StringReplace ($translationS, "&lt;", '<')
$translationS = StringReplace ($translationS, "&gt;", '>')

EndIf

; --
#ce

EndIf
EndIf

; If $howtodisplay = 1 Then
; $wholeline = "[" & $premiumornot & "]" & @TAB & "[" & $inputfilesplit[$j] & "]" & @TAB & "[" & $translation & "]"
; ElseIf $howtodisplay = 2 Then

If $howtodisplay = 2 Then
$wholeline = $translation
EndIf

; ElseIf $howtodisplay = 3 Then
; $wholeline = $translation
; ElseIf $howtodisplay = 4 Then
; $wholeline = $inputfilesplit[$j] & @TAB & "P: " & $translation & @TAB & "S: " & $translationS
; EndIf

$bigtranslation = $wholeline

; Then give user end-report

$len = StringLen ($inputfile)
$price = $len / 1000000 * 20

If $cliporno = 6 Then
If NOT ($error = 1) Then
ClipPut ($bigtranslation)
; MsgBox (0, "Translation on clipboard", "The translation is on the clipboard." & @CRLF & "Estimated cost: USD " & $price, 0)
TrayTip ("Translation on clipboard", $wholeline & @CRLF & @CRLF & "The translation is on the clipboard." & @CRLF & "Estimated cost: USD " & $price, 10)
EndIf
EndIf

EndFunc